display.setDefault( "background", 1,1,1 )
 
local function hasPhonePermission()
    -- Check to see if the user has previouslly granted permissions
    local grantedPermissions = system.getInfo( "grantedAppPermissions" )
    local hasPhonePermission = false
 
    -- Check for the "Phone" group permission
    for i = 1,#grantedPermissions do
        if ( "Phone" == grantedPermissions[i] ) then
            hasPhonePermission = true
            break
        end
    end
    return hasPhonePermission
end
 
local function appPermissionsListener( event )
 
    local phonePermissionGranted = hasPhonePermission()
    if not phonePermissionGranted then
        -- We can't continue, exit the app
        -- native.requestExit()
    else
        -- Safe to get the device ID
        device_ID = system.getInfo( "deviceID" )
    end
end
 
-- This only matters for Android 6 or later
if ( system.getInfo( "platform" ) == "android" and system.getInfo( "androidApiLevel" ) >= 23 ) then
 
    local phonePermissionGranted = hasPhonePermission()
 
    if not phonePermissionGranted then
        -- If phone permission is not yet granted, prompt for it
        local permissionOptions =
        {
            appPermission = "Phone",
            urgency = "Critical",
            listener = appPermissionsListener,
            rationaleTitle = "Read phone state required",
            rationaleDescription = "This app needs this state to retrieve previously saved data. Re-request now?",
            settingsRedirectTitle = "Alert",
            settingsRedirectDescription = "Without the ability to access your device's unique ID, it can't function properly. Please grant phone access within Settings."
        }
        native.showPopup( "requestAppPermission", permissionOptions )
    else
        -- We already have the needed permission
        device_ID = system.getInfo( "deviceID" )
    end
end

if device_ID==nil then
  device_ID="nil"
elseif device_ID=="" then
  device_ID="empty"
end

local myText = display.newText( "This Device ID is:\n\n"..device_ID, display.contentCenterX,display.contentCenterY,  system.nativeFont, 50 )
myText:setFillColor(0)
